#undef FNAME
#undef NAME
#undef ICON

/* metadata */
#define FNAME image_data_argb_start
#define NAME "Image Data ARGB"
#define ICON "data.png"

#ifndef PROTO
# ifndef UI
#  include "main.h"

/* standard var */
static int done = 0;

/* private data */
static Evas_Object *o_images[1];

/* setup */
static void _setup(void)
{
   int i;
   Evas_Object *o;
   void *pixels;

   pixels = malloc(sizeof (int) * 640 * 480);
   for (i = 0; i < 1; i++)
     {
        o = eo_add(EFL_CANVAS_IMAGE_CLASS, evas);
        o_images[i] = o;
        efl_image_content_hint_set(o, EVAS_IMAGE_CONTENT_HINT_DYNAMIC);
        efl_gfx_buffer_alpha_set(o, 0);
        efl_gfx_fill_set(o, 0, 0, 640, 480);
        efl_gfx_size_set(o, 640, 480);
        efl_gfx_visible_set(o, EINA_TRUE);
        efl_gfx_buffer_copy_set(o_images[i], pixels, 640, 480, 640 * sizeof (int), EFL_GFX_COLORSPACE_ARGB8888);
     }
   free(pixels);
   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   int i;
   for (i = 0; i < 1; i++) eo_del(o_images[i]);
}

/* loop - do things */
static void _loop(double t, int f)
{
   int i, st;
   Evas_Coord x, y, w, h;
   for (i = 0; i < 1; i++)
     {
        unsigned int *data, *p;
        int length;

        w = 640;
        h = 480;
        x = (win_w / 2) - (w / 2);
        y = (win_h / 2) - (h / 2);
        efl_gfx_position_set(o_images[i], x, y);
        efl_gfx_size_set(o_images[i], w, h);
        efl_gfx_fill_set(o_images[i], 0, 0, w, h);
        data = efl_gfx_buffer_map(o_images[i], &length,
                                  EFL_GFX_BUFFER_ACCESS_MODE_WRITE,
                                  0, 0, 0, 0, EFL_GFX_COLORSPACE_ARGB8888,
                                  &st);
        if (!data)
          {
             fprintf(stderr, "ERROR: Failed to map image!\n");
           continue;
          }
        st = st >> 2;
        p = data;
        for (y = 0; y < h; y++)
          {
             for (x = 0; x < w; x++)
               {
                  *p = ((((x * y) + f) << 8) ^ (x - y - f)) | 0xff000000;
                  p++;
               }
             p += (st - w);
          }
        efl_gfx_buffer_unmap(o_images[i], data, length);
        efl_gfx_buffer_update_add(o_images[i], 0, 0, w, h);
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(const char *key)
{
   KEY_STD;
}












/* template stuff - ignore */
# endif
#endif

#ifdef UI
_ui_menu_item_add(ICON, NAME, FNAME);
#endif

#ifdef PROTO
void FNAME(void);
#endif

#ifndef PROTO
# ifndef UI
void FNAME(void)
{
   _setup();
   ui_func_set(_key, _loop);
}
# endif
#endif
#undef FNAME
#undef NAME
#undef ICON
